/* Historie s oddlovacmi komenti: 04C_Basic_operators.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 4.0: Inicializace prosted
********************************************************************/
/open Start_04.jsh
/vars
/********************************************************************


/*
** Vpis 4.1: Pouit piazen jako vrazu
********************************************************************/
i = 100;
j = 50 + (k = i - k);   //Druh stanec obsahuje piazen
/vars i j k
/********************************************************************


/*
** Vpis 4.2: Stn textovch etzc
********************************************************************/
String s1="Dobr", s2="den", s12=s1+s2;
s12 = s1 + " " + s2;
s1 = "Dobr ";  s12 = s1+s2;
_String = "i=" + i + ", j=" + j + ", k=" + k;
/********************************************************************


/*
** Vpis 4.3: Zpsoby zpracovn dlen
********************************************************************/
9 / 8    //Oba operandy jsou cel sla => vsledek je cel slo
9.0 / 8  //Lev je typu double, prav int => vsledek je double
9 / 8F   //Lev je typu int, prav float => vsledek je float
/********************************************************************


/*
** Vpis 4.4: Opertor zbytku po dlen
********************************************************************/
System.out.println(
"\n(+5) / (+3) =  " + (+5)/(+3)  + ";  (+5) % (+3) =  " + (+5)%(+3) +
"\n(+5) / (-3) = "  + (+5)/(-3)  + ";  (+5) % (-3) =  " + (+5)%(-3) +
"\n(-5) / (+3) = "  + (-5)/(+3)  + ";  (-5) % (+3) = "  + (-5)%(+3) +
"\n(-5) / (-3) =  " + (-5)/(-3)  + ";  (-5) % (-3) = "  + (-5)%(-3)
);
double pi = 3.141592653589793
pi % 1
pi - pi % 0.01
/********************************************************************


/*
** Vpis 4.5: Implicitn petypovn a jeho monosti
********************************************************************/
_int = _char;  //Znak lze pevst na int, long, float a double
_int = _short;  //Pevd se z menho na vt => projde
_short = _int;  //Z vtho na men implicitn pevdt nelze
_byte = 127;  //Vhodn velk literl lze piadit i menm typm
_byte = 128;  //Hodnota vt ne ppustn zpsob chybu
_Object = _byte;  //Hodnoty primitivnch typ lze pevst na objekty
_Object = _String;  //Pevod z podtypu na nadtyp projde
_String = _Object;  //Z obecnjho na speciln implicitn nelze
/********************************************************************


/*
** Vpis 4.6: Explicitn petypovn hodnot primitivnch datovch typ
********************************************************************/
(j-i) / (j+i)
double plus=j+i,  minus=j-i;  //Pevod budoucch operand na double
minus / plus  //Podl operand typu double je typu double
(double)(j-i) / (j+i)  //Pevedu-li jeden, peklada pevede druh
_long = 0x0FED_CBA9_8765_4321L; //Vchoz hodnota pro dal pevody
System.out.println( //Postupn pevod na men datov typy
    "long:  0x" + Long   .toHexString(              _long) + " = " + _long
+ "\nint:   0x" + Integer.toHexString(_int  =(int  )_long) + " = " + _int
+ "\nshort: 0x" + Integer.toHexString(_short=(short)_long) + " = " + _short
+ "\nbyte:  0x" + Integer.toHexString(_byte =(byte )_long) + " = " + _byte
);
(int)(100 * pi);    //Pevod na cel slo uzne desetinnou st
_int = 'A';//Pevod znaku na slo je implicitn a poskytne kd znaku
(char)_int;//Pevod slo->znak nutno explicitn; vrt znak s danm kdem
/********************************************************************


/*
** Vpis 4.7: Explicitn petypovn hodnot objektovch typ
********************************************************************/
_String = (String)_Object;  //V promnn je string => projde
_Object = _byte;  //To u jsme dlali, probhne implicitn konverze
_byte = (byte)_Object;  //V promnn je byte => projde
/* Kdy byl v promnn _Object string, konverze prola.
   Nyn je v n ale byte, tak projt neme.
   Aby na to ale virtuln stroj piel, mus kontrolovat za bhu.
*/ _String = (String)_Object;
_String = _Object + "";
/********************************************************************


/*
** Vpis 4.8: Specifika selnch typ
********************************************************************/
_byte + _byte
_byte = (byte)(_byte + _byte)
_byte = _byte - _byte
long LONG = 9_012_345_678_901_234_567L;
double dl; float fl;
System.out.println(
        LONG    + " - long\n"
+ (dl = LONG)   + " - (double)long\n"
+ (fl = LONG)   + " - (float )long\n"
+ "LONG - dl: " + (LONG - (long)dl) + "\n"
+ "LONG - fl: " + (LONG - (long)fl)
);
'\n' + 5 + " je vsledek"
"Vsledek je " + 5 + '\n'
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 04H_Basic_operators.jsh
