/* Historie s oddlovacmi komenti: 05C_Methods.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 5.1: Definice a nsledn zavoln metody doubleText()
********************************************************************/
String text = "text";
void doubleText()
{
    text = text + text;
}
doubleText();
text
/********************************************************************


/*
** Vpis 5.2: Definice a pouit metody println(Object)
********************************************************************/
void println(Object object)
{
    System.out.println(object);
}
println(text);
println("Copyright: \u00A9\nPlusMnus: \u00b1");
/********************************************************************


/*
** Vpis 5.3: Definice a pouit metody println(Object)
********************************************************************/
void printPerson(String firstName, String secondName, String surname,
                 int birthYear)
{
    println(  "Kestn:  " + firstName
          + "\nDruh:    " + secondName
          + "\nPjmen: " + surname
          + "\nBylo by/Je mu/j " + (2020 - birthYear) + " let"
           );
}
printPerson("Josef", "Vclav", "Sldek", 1840);
printPerson("Karel", "",       "apek",  1890);
/********************************************************************


/*
** Vpis 5.4: Definice a pouit metody hypotenuse(double, double)
********************************************************************/
double hypotenuse(double a, double b)
{
    return Math.sqrt(a * a  +  b * b);
}
hypotenuse(3, 4);  //M vyjt 5, protoe 3*3 + 4*4 = 25
hypotenuse(5, 12);  //M vyjt 13, protoe 5*5 + 12*12 = 25+144 = 169
hypotenuse(1, 1);  //M vyjt cca 1.414 = odmocnina ze dvou
/********************************************************************


/*
** Vpis 5.5: Pouit petench verz metod
********************************************************************/
Math.max(1, 3);  //Oba typu int => pouije se verze int
Math.max(1L, 3);  //Prvn typu long, druh int => pouije se long
Math.max(1, 3.0);  //Prvn int, druh double => pouije se double
void xxx(int i) { println("Verze int s hodnotou " + i); }
void xxx(double d) { println("Verze double s hodnotou " + d); }
xxx(1);     //Argument typu int -> pouije se verze int
xxx(2L);    //Argument typu long -> pouije se verze double
/********************************************************************


/*
** Vpis 5.6: Lokln promnn a jejich pouit
********************************************************************/
void local() //Chybn zadan pouit promnn ped piazenm hodnoty
{
    String local;
    println(local);
}
void local() //Redefinice, v n je promnn nejprve piazena
{            //hodnota, a teprve pot je promnn pouita
    String local;
    println("Budeme piazovat");
    local = "Hodnota piazena";
    println(local);
}
local();    //Voln prv definovan metody
local = "Piazen";  //Pro okoln program promnn local neexistuje
/********************************************************************


/*
** Vpis 5.7: Pklad
********************************************************************/
/** Do zvodn jdelny koupili 15 kg oech a o 29 kg vce vestek.
 *  Jablek koupili 6krt vce ne vestek.
 *  Kolik kilogram jablek koupili? */
void jdelna()
{
    int oech  = 15;
    int vestek = oech + 29;
    int jablek  = vestek * 6;
    println("Zvodn jdelna nakoupila " + jablek + " kg jablek");
}
jdelna();
double hypotenuse(double a, double b)
{
    double result = Math.sqrt(a * a  +  b * b);
    return result;
}
/********************************************************************


/*
** Vpis 5.8: Metody s promnnm potem parametr
********************************************************************/
void variant(String title, int... params)
{
    int count = params.length;
    println(count + " volitelnch argument pro " + title);
}
variant("Nic");
variant("Pt", 1, 2, 3, 4, 5);
/********************************************************************


/*
** Vpis 5.9: Vpis aktivnch metod pkazem /methods
********************************************************************/
/methods
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 05H_Methods.jsh
