/* Historie s oddlovacmi komenti: 07C_Arrays.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 7.0: Inicializace prosted  definice pomocnch metod a promnnch
********************************************************************/
/set start Start_07.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Vpis 7.1: Deklarace a inicializace pol
********************************************************************/
int[] aInt;
String[] aString;
"aInt=" + aInt + ", aString=" + aString;
double[] aDouble = {0, 1.0, 2F};
Object[] aObject = {"nula", 1, 2.0, 6/2D, null, 0/0D};
"aDouble=" + aDouble + ", aObject=" + aObject;
println(
      "aDouble=" + Arrays.toString(aDouble)
  + "\naObject=" + Arrays.toString(aObject));
/********************************************************************


/*
** Vpis 7.2: Piazovn hodnot polm
********************************************************************/
aInt = new int[8];
aInt = new int[] {0, 100, 200, 300};
println("aInt="+Arrays.toString(aInt));
aObject = new String[] { "nic vc" };
aDouble = aInt;
aString = new String[] {};
void printStringArray(String title, String[] stringArr)
{
    println(title + "=" + Arrays.toString(stringArr));
}
printStringArray("aObject", (String[])aObject);
String[] stringArray(int n) { return new String[n]; }
printStringArray("Vrceno metodou stringArray(int)", stringArray(2));
/********************************************************************


/*
** Vpis 7.3: Zjiovn dlky pole
********************************************************************/
aInt.length
aString.length
stringArray(5).length
/********************************************************************


/*
** Vpis 7.4: Prce s prvky pole
********************************************************************/
aObject[0]
aObject[1]
(aString = stringArray(3))[2] = "Druh";
aString[0] = "nult";
aString[1] = "za mnou je " + aString[2];
printStringArray("Naplnn aString", aString);
/********************************************************************


/*
** Vpis 7.5: Obdlnkov pole
********************************************************************/
String[][] a2String = new String[2][3];
a2String[0][1] = "nula-jedna";
a2String[1][2] = "jedna-dva";
println(arr2toString("Obdlnkov, tu tam inicializovan", a2String));
a2String[0]
/********************************************************************


/*
** Vpis 7.6: Zubat pole
********************************************************************/
String[][] demo() { //Ukzka postupn tvorby zubatho pole
    String[][] arr2 = new String[3][];
    arr2[0] = new String[]{"00", "01", "02"};
    arr2[1] = new String[2];
    return arr2;
} aObject = demo();
println(arr2toString("Zubat, postupn vytven",
                     (Object[][])aObject));
a2String = new String[][]{ {"a", "b", "c"},
                           {},
                           {"w", "x", "y", "z"},
                         };
println(arr2toString("Zubat, pmo inicializovan", a2String));
/********************************************************************


/*
** Vpis 7.7: Promnn poet argument
********************************************************************/
void variant(String title, int... args)
{
    int count = args.length;
    println(count + " argument pro " + title);
    println("Argumenty: " + Arrays.toString(args));
}
variant("Nic");
variant("Pt", 1, 2, 3, 4, 5);
/********************************************************************


/*
** Vpis 7.8: Emulace pedvn argumentu odkazem
********************************************************************/
String passByReturn(String arg, boolean change)
{
    String result = change ? "Jin objekt" : arg;
    return result;
}
{ String s="Pvodn string";
  s=passByReturn(s, false); println("Nezmnno: s=" + s);
  s=passByReturn(s, true ); println("Zmnno:   s=" + s);
}
String passByReference(String[] arg, boolean change)
{
    arg[0] = change ? "Jin objekt" : arg[0];
    return "Objekt " + (change ? "BYL" : "NEBYL") + " vymnn";
}
{ String s="Pvodn string"; String[]as={s};
  println(passByReference(as, false) + " - " + Arrays.toString(as));
  println(passByReference(as, true ) + " - " + Arrays.toString(as));
}
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 07H_Arrays.jsh
