/* Historie s oddlovacmi komenti: 08C_Conditions.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 8.0: Inicializace prosted  definice pomocnch metod a promnnch
********************************************************************/
/set start Start_07.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Vpis 8.1: Jednoduch podmnn pkaz
********************************************************************/
String demoIf(boolean b)
{
    String result = "Podmnka";
    if (!b) result += " nen";
    result += " splnna";
    return result;
}
println(demoIf(true));
println(demoIf(false));
/********************************************************************


/*
** Vpis 8.2: Blok pkaz
********************************************************************/
void printSqrt(double number)   //Tiskne druhou odmocninu zadanho sla
{
    if (number < 0) {
        println("Odmocovan slo nesm bt zporn!");
        return;
    }
    double result = Math.sqrt(number);
    println("Odmocnina z sla " + number + " = " + result);
}
printSqrt(2);
printSqrt(-2);
/********************************************************************


/*
** Vpis 8.3: Vnoovn blok a pouvn loklnch promnnch
*********************************************************************/
void localInBlock(int request)
{
    int level = 0; //Hladina zanoen
    println("Nachzme se ve vnjm bloku - hladina=" + level);
    if (request > 0 )
    {
        int first = ++level;
        println("  Vnitn blok - hladina=" + first);
        int second;
//        println("  Neinicializovan => nepouiteln: " + second);
        if (request > 1)
        {
            second = ++level;
            println("    Vnitnj blok - hladina=" + level
                    + "(" + second + "/" + first + ")");
            {
                //Jen si tu na chvli nco deklaruji
                int third = ++level;
                println("      Nejvnitnj blok - hladina=" + level
                    + "(" + third + "/" + second + "/" + first + ")");
                level--;
            }
            println("    Za nejvnitnjm blokem - hladina=" + level);
            println("    First:  Deklarovan a inicializovan ve vnjm "
                      + "bloku => pouiteln: " + first);
            println("    Second: Deklarovan ve vnjm bloku, "
                      + "inicializovan zde => pouiteln: " + second);
            println("    Third:  Deklarovan ve vnitnm bloku => "
                      + "nedosaiteln");
//            println( third);
            --level;
        }
        println("Za vnitnjm blokem - hladina=" + level);
        println("  First: Deklarovan a inicializovan v tomto bloku "
                + "=> pouiteln: " + first);
        println("  Second: Deklarovan v tomto bloku, ale inicializovan "
              +                                   "v podmnnm pkazu\n"
              + "          => inicializace nen jist => nepouiteln");
//        println(second);
        level--;
    }
    println("Za vnitnm blokem zpt ve vnjm bloku - hladina=" +level);
    println("First: Deklarovan ve vnitnm bloku => nedosaiteln");
//    println(first);
}
/********************************************************************


/*
** Vpis 8.4: Voln metody definovan ve vpisu 8.3
********************************************************************/
localInBlock(0);
localInBlock(2);
/********************************************************************


/*
** Vpis 8.5: pln podmnn pkaz
********************************************************************/
void plusminus(int number)
{
    if (number >= 0) {
        println("Hodnota je nezporn: " + number);
    }
    else {
        println("Hodnota je zporn: " + number);
    }
}
plusminus(-1);plusminus(0);plusminus(+1);
/********************************************************************


/*
** Vpis 8.6: Zanoovn pkaz pi vbru z vce monost
*********************************************************************
if( monost_1 ) {
    //Reakce na prvn monost
}
else {
    if( monost_2 ) {
        //Reakce na druhou monost
    }
    else {
        if( monost_3 ) {
            //Reakce na tet monost
        }
        else {
           //Zbyl monosti
        }
    }
}
/********************************************************************


/*
** Vpis 8.7: Doporuen formtovn pi vbru z vce monost
*********************************************************************
if( monost_1 ) {
    //Reakce na prvn monost
}
else if( monost_2 ) {
    //Reakce na druhou monost
}
else if( monost_3 ) {
    //Reakce na tet monost
}
else {
    //Zbyl monosti
}
/********************************************************************


/*
** Vpis 8.8: Definice metody sqrt(double,double,double)
              ec kvadratickou rovnici
********************************************************************/
public void sqrt(double a, double b, double c)
{
    println("Rovnice " + a + "*x^2 + " + b + "*x + " + c + " = 0");
    double discriminant = b * b  - 4 * a * c;
    double a2 = 2 * a;
    if (discriminant > 0) {
        double sqrd = Math.sqrt(discriminant);
        double x1 = (-b - sqrd) / a2;
        double x2 = (-b + sqrd) / a2;
        println("m dv reln een: x1 = " + x1
            + "\n                      x2 = " + x2);
    }
    else if (discriminant == 0) {
        double x12 = -b / a2;
        println("m dvojnsobn een: x12 = " + x12);
    }
    else {
        double re = -b / a2;
        double im = Math.sqrt(-discriminant) / a2;
        println("m komplexn een: x = " + re + "  " + im + "i");
    }
}
/********************************************************************


/*
** Vpis 8.9: Voln metody sqrt(double,double,double)
              ec kvadratickou rovnici
********************************************************************/
sqrt(1, 0,-9);
sqrt(1, 2, 1);
sqrt(1, 0, 9);
/********************************************************************


/*
** Vpis 8.10: Koncepce pepnae (pkazu switch) pevzat z jazyka C
*********************************************************************
switch (vraz)
{
   case konstatn_hodnota_1:
       //Akce, kter se m spustit, m-li vraz hodnotu hodnota_1
       break;

   case konstatn_hodnota_2:
       //Akce, kter se m spustit, m-li vraz hodnotu hodnota_2
       break;

    //...   Dal mon vtve

    default:     //Tato st je nepovinn
        //Akce spoutn v ppad, kdy vsledkem vrazu
        //nen dn z ve vyjmenovanch hodnot.
}
/********************************************************************


/*
** Vpis 8.11: Novj koncepce pepnae (pkazu switch)
*********************************************************************
switch (vraz)
{
   case KH_1 -> print("Vykonat pi hodnot KH_1.");

   case KH_2 -> {
       print("Vykonat pi hodnot KH_2.");
       print("Sloitj akce je teba uzavt do bloku kdu,");
       print("aby se z nich stal jeden, by sloitj, pkaz");
   }

    //...   Dal mon vtve

    default -> print("Jin hodnota promnn vraz")
}
/********************************************************************


/*
** Vpis 8.12: Ukzka pouit klasick verze pepnae (pkazu switch)
********************************************************************/
void sDemo(String day)
{
    String start = " - Pracuji ",  level = "tm ",  add = "";
    switch(day)
    {
        default:
            println(day + " - Je vkend => nepracuje se");
            break;
        case "PONDL":
            println(day + start + "zvolna, vzpamatovvm se z vkendu");
            break;
        case "STEDA":
            level = "";
            add = "\n         Den s nejkvalitnjmi vrobky";
        case "TER":
        case "TVRTEK":
            println(day + start + level + "naplno" + add);
            break;
        case "PTEK":
            println(day + start + "zvolna, u se tm na vkend");
            break;
    }
}
/********************************************************************


/*
** Vpis 8.13: Voln metody vyuvajc pepna
********************************************************************/
{sDemo("PONDL");sDemo("TER"); sDemo("STEDA"); sDemo("TVRTEK");
 sDemo("PTEK");  sDemo("SOBOTA");sDemo("NEDLE");}
/********************************************************************


/*
** Vpis 8.14: Ukzka pouit novj verze pepnae (pkazu switch)
********************************************************************/
void nDemo(String day)
{
    String start = " - Pracuji ",  add = "tm naplno";
    switch(day)
    {
        default -> { start = "";
                     add   = " - Je vkend => nepracuje se";
                   }
        case "PONDL" -> add = "zvolna, vzpamatovvm se z vkendu";
        case "STEDA"  -> { add = "naplno\n         " +
                                  "Den s nejkvalitnjmi vrobky";
            }
        case "TER", "TVRTEK" -> {}
        case "PTEK" -> add = "zvolna, u se tm na vkend";
    }
    println(day + start + add);
}
/********************************************************************


/*
** Vpis 8.15: Voln metody vyuvajc novj verzi pepnae
********************************************************************/
{nDemo("PONDL");nDemo("TER"); nDemo("STEDA"); nDemo("TVRTEK");
 nDemo("PTEK");  nDemo("SOBOTA");nDemo("NEDLE");}
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 08H_Conditions.jsh
