/* Historie s oddlovacmi komenti: 15C_Interface.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 15.0: Inicializace prosted  definice pomocnch metod a promnnch
********************************************************************/
/set start Start_07.jsh
/reset
/********************************************************************


/*
** Vpis 15.1: Definice interfejsu IInterfaceTypical
********************************************************************/
/*Definice z NetBeans:
14-28_Projects\src\eu\pedu\b62_j14\c15_interface\IInterfaceTypical.java
/********************************************************************


/*
** Vpis 15.2: Definice a pouit interfejsu IInterfaceTypical v JShell
********************************************************************/
interface IInterfaceTypical {
    public abstract void methodExp();
    void method();
}
class IntTImpl_1 implements IInterfaceTypical {
    private static int created = 0; private int id = ++created ;
    public String toString() { return "IntTImpl_1(" + id + ")"; }

    IntTImpl_1() {println("Vytvoena instance " + this);}
    public void methodExp() { println("  "+this + ".methodExp()"); }
    public void method()    { println("  "+this + ".method()");    }
}
class IntTImpl_2 implements IInterfaceTypical {
    IntTImpl_2() {println("IntTImpl_2 -- vytvoeno");}
    public void methodExp() { println("  Zavolna methodExp()"); }
    public void method()    { println("  Zavolna method()");    }
}
void intImplTest(IInterfaceTypical iit) {
    iit.methodExp();
    iit.method();
}
{ intImplTest(new IntTImpl_1());
  intImplTest(new IntTImpl_2()); }
/********************************************************************


/*
** Vpis 15.3: Definice demonstranho interfejsu IInterfaceFull
 *             obsahujcho vechny povolen typy len
********************************************************************/
/*Definice z NetBeans
14-28_Projects\src\eu\pedu\b62_j14\c15_interface\IInterfaceFull.java
/********************************************************************


/*
** Vpis 15.4: Demonstrace kolize ddnch metod a jej een
********************************************************************/
interface I1 {
    void mAbstract();
    default void m1d()      { println("I1.m1d()"); }
    default void mDefault() { println("I1.mDefault()"); }
}
interface I2 {
    void mAbstract();
    default void m2d()      { println("I2.m2d()"); }
    void mDefault();
}
class Cls implements I1, I2 {
    public void mAbstract() { println("Cls.mAbstract()"); }
}
interface I2 {
    void mAbstract();
    default void m2d()      { println("I2.m2d()"); }
    default void mDefault() { println("I2"); }
}
class Cls implements I1, I2 {
    public void mAbstract() { println("Cls.mAbstract()"); }
}
class Cls implements I1, I2 {
    public void mAbstract() { println("Cls.mAbstract()"); }
    public void mDefault () { println("Cls.mDefault()");  }
}
/********************************************************************


/*
** Vpis 15.5: Specifikace pedka, jeho metodu volm
********************************************************************/
class Cls2 implements I1, I2 {
    public void mAbstract() { println("Cls2.mAbstract()"); }
    public void mDefault () { I1.super.mDefault(); I2.super.mDefault(); }
    public void m1d      () { I1.super.m1d();  I2.super.m2d();  m2d(); }
}
new Cls2().mDefault();
new Cls2().m1d();
new Cls2().m2d();
/********************************************************************


/*
** Vpis 15.6: Mon problmy pi ddn interfejs
********************************************************************/
interface I11 extends I1 {
    default void mDefault() { println("I11-2. generace"); }
}
class Cls11 implements I11 {
    public void mAbstract() { mDefault(); I1.super.mDefault(); }
}
interface I12 extends I1, I2 {
}
interface I12 extends I1, I2 {
    default void mDefault () { I1.super.mDefault(); }
}
/********************************************************************


/*
** Vpis 15.7: Pouit dvojtekovho cyklu for (cyklu for-each)
** pro iterovateln objekty
********************************************************************/
List<String> seasons = List.of("Jaro", "Lto", "Podzim", "Zima");
for (String name : seasons) {
    System.out.println(name);
}
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 15H_Interface.jsh
