//Soubor: 17D_Daughter.jsh
//################################## Pli luouk k pl belsk dy
//#########################################################################

/*******************************************************************************
 * Instance tdy {@code Daughter} pedstavuj dcery.
 *
 * @author  Rudolf PECINOVSK
 * @version 2020-Summer
 */
class Daughter extends Mother
{
    static { println("#####  Zavdm tdu Daughter  #####"); }
    { println("+++++  Inicializuji instanci tdy Daughter  +++++"); }

    /** Poet doposud vytvoench instanc.*/
    protected static int created = 0;

    /** Rodn slo instance = poad jejho vzniku v rmci tto tdy. */
    protected final String ID = "D"  + ++created + '-' + super.ID;


    /***************************************************************************
     * Konstruktor instance dcery.
     * Rodiovskm podobjektem je virtuln instance tdy {@link Mother}.
     */
    public Daughter()
    {
        this(null);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kte potebuj nco provst
     * ped zavolnm rodiovskho konstruktoru.
     *
     * @param s Nepouit parametr
     */
    protected Daughter(String s)
    {
        super(intermezzo("=== Daughter vol rodiovsk konstruktor"));
        constructorReport(this, Daughter.class);
    }

    /***************************************************************************
     * Vrt textov podpis instance, tj. jej etzcovou reprezentaci.
     *
     * @return Textov reprezentace (podpis) dan instance
     */
    @Override
    public String toString()
    {
        return "Daughter_" + ID + "(" + super.toString() + ")";
    }

    { println("-----  Konec vodn fze inicializace Daughter  -----"); }
    static { println("-----  Tda Daughter zavedena  -----"); }
}



/**Vpis
**************************************************************************/
//#########################################################################
