/* Historie s oddlovacmi komenti: 23C_TypeArguments.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 23.0: Inicializace
********************************************************************/
/set start Start_17.jsh
/reset
/********************************************************************


/*
** Vpis 23.1: Definice td ListTest1 a ListTest2
********************************************************************/
class ListTest1 <E, L extends List<E>> { /* Tlo tdy */ }
class ListTest2 <L extends List<E>, E> { /* Tlo tdy */ }
/********************************************************************


/*
** Vpis 23.2: Definice td ParentChild a ChildParent
********************************************************************/
class ParentChild<Parent, Child extends Parent> { /* Tlo tdy. */ }
class ChildParent<Child extends Parent, Parent> { /* Tlo tdy. */ }
/********************************************************************


/*
** Vpis 23.3: Definice tdy a zptn peloen verze jejho pekladu
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c23_typearguments\Erasure_Before_After.java
*/
/********************************************************************


/*
** Vpis 23.4: Definice tdy UpperStringList
********************************************************************/
/*Definice:
B62_Lib_Pkg\src\eu\pedu\b62_j14\c23_typearguments\UpperStringList.java
*/
/********************************************************************


/*
** Vpis 23.5: Definice pemosovac metody
********************************************************************/
/*Definice:
Pekladaem pidan pemosovac metoda
*/
/********************************************************************


/*
** Vpis 23.6: Definice tdy Prohibited
********************************************************************/
class Prohibited<T>
{
    T t = new T();
}
/********************************************************************


/*
** Vpis 23.7: Definice pol instanc tdy ArrayList
********************************************************************/
ArrayList<String>[] listS = new ArrayList<>[5];
ArrayList<String>[] listS = new ArrayList<String>[5];
ArrayList[] listR = new ArrayList[5];
ArrayList<String>[] listS = new ArrayList[5];
listS[0] = new ArrayList<String>();
listS[1] = new ArrayList<Integer>();
/********************************************************************


/*
** Vpis 23.8: Definice metody pouvajc promnn poet argument
 *             parametrizovanho typu
********************************************************************/
public void mtd(List<String>... lists){}
/********************************************************************


/*
** Vpis 23.9: Mon nekorektn operace
********************************************************************/
@SafeVarargs void m(List<String>... stringLists) {  // Not actually safe!
    Object[] array = stringLists;
    List<Integer> tmpList = Arrays.asList(42);
    array[0] = tmpList; // Semantically invalid, but compiles without warnings
    String s = stringLists[0].get(0); // Oh no, ClassCastException at runtime!
}
/********************************************************************


/*
** Vpis 23.10: Vytvoen pole typovho parametru
********************************************************************/
@SafeVarargs <E> E[] arrayOf(E... array) { return array; }
var aint = arrayOf(1, 3, 5, 7, 11);
var astr = arrayOf("Raz", "Dva", "Ti");
Object[] oo = aint;
oo[0] = "NULA";
/********************************************************************


/*
** Vpis 23.11: Definice generick tdy Crate12
********************************************************************/
public class Crate12<T1, T2>
{
    T1 t1;
    T2 t2;

    public T1 get1() { return t1; }
    public T1 get2() { return t1; }

    public void set(T1 o)  { t1 = o; }
    public void set(T2 o)  { t2 = o; }
}
/********************************************************************


/*
** Vpis 23.12: Definice generick tdy Crate11
********************************************************************/
public class Crate11<T>
{
    T t1, t2;

    public boolean equals(T t)
    {
        return (t1.equals(t) && t2.equals(t));
    }
}
/********************************************************************


/*
** Vpis 23.13: Definice td Parent, Child a IntervalD
********************************************************************/
public class IntervalD<T extends Comparable<T>> {
    public IntervalD(T lower, T upper) {}
}
class Parent implements Comparable<Parent> {
    public int compareTo(Parent r)  { return 0; }
}
class Child extends Parent {  //implements Comparable<Parent>
    public int compareTo( Parent r )  { return 0; }
}
IntervalD<Parent> icp = new IntervalD<>(new Parent(), new Child());
IntervalD<Child> icc = new IntervalD<>(new Child(), new Child());
/********************************************************************


/*
** Vpis 23.14: Upraven (ale patn) definice tdy Child
********************************************************************/
class Child extends Parent implements Comparable<Child> {
    public int compareTo( Parent r )  { return 0; }
}
/********************************************************************


/*
** Vpis 23.15: Definice tdy Interval<T extends Comparable<? super T>>
********************************************************************/
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 23H_TypeArguments.jsh
