/* Historie s oddlovacmi komenti: 26C_Records.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 26.0: Inicializace
********************************************************************/
/set start Start_26.jsh
/reset
/********************************************************************


/*
** Vpis 26.1: Definice zznamu o trojhelnku definovanm podle vty SSS
**             (Side-Side-Side) a pehled jeho metod
********************************************************************/
record TriangleSSS(double a, double b, double c) {}
new TriangleSSS(1, 2, 3);
printFCM(TriangleSSS.class);
/********************************************************************


/*
** Vpis 26.2: Definice interfejsu charakterizujcho zznamy
**             o trojhelncch definovanch podle vty SSS
**             a zznamu implementujcm tento interfejs
********************************************************************/
interface ITriangleSSS
{
    double a();
    double b();
    double c();
}
record TriangleSSSi(double a, double b, double c)
implements ITriangleSSS
{}
ITriangleSSS it = new TriangleSSSi(11, 22, 33);
/********************************************************************


/*
** Vpis 26.3: Definice zznamu s explicitn definic kanonickho konstruktoru
********************************************************************/
record TriangleSSSe(double a, double b, double c)
implements ITriangleSSS
{
    public TriangleSSSe
    {
        println ("Vytvoen zznam o trojhelnku " + this);
    }
}
printFCM(TriangleSSSe.class);
it = new TriangleSSSe(10, 20, 30);
/********************************************************************


/*
** Vpis 26.4: Upraven definice zznamu s explicitn definic kanonickho konstruktoru
********************************************************************/
record TriangleSSSec(double a, double b, double c)
implements ITriangleSSS
{
    public TriangleSSSec
    {
        this.a = a;
//        this.b = b;
        this.c = c;
        println ("Vytvoen zznam o trojhelnku " + this);
    }
}
it = new TriangleSSSec(101, 202, 303);
/********************************************************************


/*
** Vpis 26.5: Uvedeme-li parametry konstruktoru, musme je inicializovat
********************************************************************/
record TriangleSSSecw(double a, double b, double c)
{
    public TriangleSSSecw(double a, double b, double c)
    {
        println ("Vytvoen zznam o trojhelnku " + this);
    }
}
/********************************************************************


/*
** Vpis 26.6: Prvn st definice zznamu RightTriangleSSS obsahujc
**             definice statickch atribut a konstruktor
********************************************************************/
/*Definice:
j:\62_PGM\JSH\26D_RightTriangleSSS.jsh
1. st
*/
/********************************************************************


/*
** Vpis 26.7: Provrka funkcionality konstruktor zznam typu RightTriangleSSS
********************************************************************/
/open 26D_RightTriangleSSS.jsh
new RightTriangleSSS(2, 3, 4, 5);
var rt34 = new RightTriangleSSS(3, 4);
var rt11 = new RightTriangleSSS(Math.sqrt(2));
/********************************************************************


/*
** Vpis 26.8: Druh st definice zznamu RightTriangleSSS obsahujc
**             definice pebitch a novch instannch metod
********************************************************************/
/*Definice:
j:\62_PGM\JSH\26D_RightTriangleSSS.jsh
2. st
*/
/********************************************************************


/*
** Vpis 26.9: Provrka funkcionality definovanch instannch metod
********************************************************************/
rt11.alphaBeta();
rt34.equals(rt11)
it = new RightTriangleSSS(3, 4)
rt34.equals(it);  it.equals(rt34)
rt34.hashCode() - it.hashCode()
it = new TriangleSSSi(3, 4, 5)
rt34.equals(it);  it.equals(rt34)
rt34.hashCode() - it.hashCode()
/********************************************************************


/*
** Rekapitulace a zvren uloen
********************************************************************/
/imports
/vars
/methods
/types
/save -history 26H_Records.jsh
