/* Historie s oddlovacmi komenti: 02C_Literals.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis X.0: Inicializace
********************************************************************/
/********************************************************************


/**Vpis 2.1: Literly typu boolean
********************************************************************/
false   //NE, neplat, nepravda, ...
true    //ANO, plat, pravda, ...
/********************************************************************


/*
** Vpis 2.2: Literly typu int v rznch selnch soustavch
********************************************************************/
0b1_0111    //23 = 1*16 + 0*8 + 1*4 + 1*2 + 1*1 = 0x17
0B10_111    //027 - slo upraven pro pevod na osmikov
027         //Stejn slo zapsan v osmikov soustav
0x17        //Stejn slo zapsan v estnctkov soustav
08          //Zan nulou, ale obsahuje pli velkou slici
Ox17   //Zan psmenem O => nen to slo, ale identifiktor
/********************************************************************


/*
** Vpis 2.3: Literly typu long
********************************************************************/
0L              //Nula typu long
1_234_567_890   //Vejde se do typu int
9_876_543_210   //Chyba: Nem pponu a na int moc velk
9_876_543_210L  //Sprvn zapsan slo typu long
/********************************************************************


/*
** Vpis 2.4: Rzn zpsoby zadn literl typu double
********************************************************************/
9_876_543_210D  //Stejn jako minule, ale nyn typu double
0D              //Nula typu double
0.012345        //Zpis s pevnou dovou (desetinnou) tekou
12345e-6        //Tot slo zapsan v exponentovm tvaru
123.45e67       //Trochu vt slo
/********************************************************************


/*
** Vpis 2.5: Literly typu float
********************************************************************/
123.45e6F   //slo typu float
0f          //Nula typu float
/********************************************************************


/*
** Vpis 2.6: Literly typu char
********************************************************************/
'\u263A'    //Znak "usmvek" - ?
'\u00AB'    //Znak '' - 0xAB = 0b1010_1011 = 0b10_101_011 = 0253
'\u00bB'    //Znak '' - ukzka, e nezle na velikosti psmen
'\253'      //Znak '' zapsan v osmikov soustav
'"'         //Znak uvozovek zadan pmo
'\"'        //Znak uvozovek zadan pes escape sekvenci
/********************************************************************


/*
** Vpis 2.7: Literly typu String
********************************************************************/
"Text v \"uvozovkch\" a \'apostrofech'"
System.out.println($23)
"Prvn dek\nDruh dek\nTet dek"
System.out.println($25)
"Prvn st dlouhho textu rozdlenho do vce st" +
"\nDruh st onoho dlouhho textu" +
" - a tet st"
System.out.println($27)
"String, kter na danm dku nekon
/********************************************************************


/*
** Vpis 2.8: Textov bloky
********************************************************************/
"""Njak text"""
"""
    <html>
      <body>
        <p>Hello, world</p>
      </body>
    </html>
    """
System.out.println($29)
"""
   Potek  -\
     prostedek    \
   -    konec    """
"""
    \s Odsazen      \s
         Odsazenj \s"""
System.out.println($29)
/********************************************************************


/*
** Vpis 2.9: Nestandardn hodnoty relnch typ
********************************************************************/
1.0 / 0   //Kladn nekoneno typu double
-1D / 0   //Zporn nekoneno typu double
0D / 0    //Neexistujc hodnota (Not a Number) typu double
1F / 0    //Kladn nekoneno typu float
-1F / 0   //Zporn nekoneno typu float
0F / 0    //Neexistujc hodnota (Not a Number) typu float
0 / 0     //U celch sel zpsob dlen nulou chybu (vyhod vjimku)
1e30F/1e-30f   //Sta dlit velk slo slem dostaten malm
1e300/1e-300   //U typu double je ono dostaten trochu vt
0 / 1.0    //Kladn nula
0 / -1D    //Zporn nula
0 / -1     //Cel sla maj pouze jednu nulu
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 02H_Literals.jsh
