/* Historie s oddlovacmi komenti: 06C_Remaining_operators.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 6.0: Inicializace prosted  definice pomocnch metod a promnnch
********************************************************************/
/set start Start_06.jsh
/reset
/methods
/vars
/********************************************************************


/*
** Vpis 6.1: Porovnvn desetinnch sel
********************************************************************/
double d1 = 0.1,  d2 = 0.2,   d3 = 0.3;
boolean equal = ((d1 + d2) == d3);
double difference = (d1 + d2)  -  d3;
equal = Math.abs(d1+d2 - d3) < 1e-15;
/********************************************************************


/*
** Vpis 6.2: Porovnvn string
********************************************************************/
String sd1 = "Dobr",  sd2 = " den";
String s1 = "Dobr den",  s2 = sd1 + sd2,  s3 = "Dobr" + " " + "den";
boolean p12 = s1==s2,  p13 = s1==s3,  p23 = s2==s3;
p12 = s1.equals(s2);   p13 = s1.equals(s3);   p13 = s1.equals(s3);
/********************************************************************


/*
** Vpis 6.3: Podmnn (zkrcen) a nepodmnn logick opertory
********************************************************************/
boolean yes()  { println("Provdno yes()");  return true; }
boolean no()  { println("Provdno no()");   return false; }
no() || yes();  //Vyhodnot se ob metody
yes() || no();  //Vyhodnot se jen prv, druh nen poteba
yes() | no();  //Nezkrcen vyhodnocen => vyhodnot se ob
yes() && no();  //Vyhodnot se ob metody
no() && yes();  //Vyhodnot se jen prv, druh nen poteba
no() & yes();  //Nezkrcen vyhodnocen => vyhodnot se ob
/********************************************************************


/*
** Vpis 6.4: Ppravn ryvky
********************************************************************/
short s35AC = 0x35AC;   //Deklace promnn, se kterou budeme operovat
~s35AC; //Vsledek bitovch operac nad hodnotami malch typ je int
void prln(int x) { println(toIntBin(s35AC) + " = 0x0000_35AC = "
          + s35AC + '\n' + toIntBin(x)     + " = " + toIntHex(x)
                                           + " = " + x); }
prln(0xFF0);    //slo 0xFF0 budeme pouvat jako druh operand
/********************************************************************


/*
** Vpis 6.5: Bitov logick operace
********************************************************************/
prln(~s35AC);  //Bitov negace - bity vsledku jsou negac pvodnch
prln(s35AC & 0xFF0);  //Konjunkce jednotlivch bit
prln(s35AC | 0xFF00);  //Disjunkce jednotlivch bit
prln(s35AC ^ 0xFF00);  //XOR jednotlivch bit
/********************************************************************


/*
** Vpis 6.6: Bitov posunov operace
********************************************************************/
prln(s35AC << 4); //Posun bit o 4 vlevo (ekvivalent nsoben 2^4=16)
prln(s35AC * 16);   //Nsoben sla slem 2^4 = 16
prln(s35AC >> 4);   //Posun bit o 4 vpravo (ekvivalent dlen 2^4)
prln(s35AC / 16);   //Celoseln dlen sla slem 2^4 = 16
/*ist posun vrt pro kladn slo stejn vsledek jako znamnkov
*/ prln(s35AC >>> 4);
s35AC = (short)-s35AC; //Zmnm znamnko pro demo zpornch sel
/* Bn (znamnkov) posun (ekvivalent dlen) zachov znamnko
*/ prln(s35AC >> 4);
prln(s35AC >>> 4); //ist posun nuluje nejvy bit
/********************************************************************


/*
** Vpis 6.7: Sloen piazovac opertory
********************************************************************/
_byte = 5;          //Zatm tam bylo nula, tak aby bylo vidt zmnu
_byte += _byte;     //Ekvivalentn pkaz nm ve vpisu 4.8 neproel
println(_byte);     //Pedchoz ohlaoval pomocnou promnnou
_int = 100 * 3.14;  //Bez explicitnho petypovn neprojde
_short = 100;       //Zatm tam byla nula
_short *= 3.14;     //Nsoben celho sla relnm
println(_short);    //Aby bylo opt vidt zmnu hodnoty
/********************************************************************


/*
** Vpis 6.8: Ternrn opertor
********************************************************************/
String ternary(boolean condition)
{
    return "Podmnka " + (condition  ?  "plat"  :  "neplat");
}
println('+' + ternary(1>2) + "\n-" + ternary(2 > 1));
String ternary(boolean c1, boolean c2)
{
    String result = "Platnost: " + (c1  ?  (c2  ?  "ANO, ANO"
                                                :  "ANO, NE")
                                        :  (c2  ?  "NE, ANO"
                                                :  "NE, NE" ))
                                 + ((c1 & c2)   ?  ""  :  "\n");
    return result;
}
println(ternary(false, false) + ternary(false, true)
      + ternary(true,  false) + ternary(true,  true));
String ternary(double d) {
    String signum = (d < 0)  ?  "zporn"
                  : (d == 0) ?  "nula"
                  : (d > 0)  ?  "kladn"
                  : "NaN";
    return "slo " + d + " je " + signum + '\n';
}
println(ternary(-1) + ternary(0) + ternary(1) + ternary(0D/0)
                    + ternary(1.0/0) + ternary(-1.0/0) );
/********************************************************************


/*
** Vpis 6.9: Definice metody equal(double,double)
 *            porovnvajc reln sla
********************************************************************/
boolean equal(double d1, double d2)
{
    boolean result = ((d1 - d2) == 0)  ?  true
                   : (d1 == 0)         ?  false //Abych nedlil nulou
                   : Math.abs((d1 - d2) / d1) < 1e-10;
    return result;
}
/********************************************************************


/*
** Vpis 6.10: Vyuit pepnae (vrazu switch) v definicch metod
**             pro vpoet potu dn v zadanm msci
********************************************************************/
int modulo(int divident, int divisor) {
    return (divident % divisor == 0)  ?  1  :  0;
}
int monthDays (int monthNum, int year)
{
    return switch (monthNum)  {
        case 1, 3, 5, 7, 8, 10, 12 -> 31;
        case 4, 6, 9, 11           -> 30;
        case 2 -> 28 + modulo(year, 4)
                     - modulo(year,100) + modulo(year,400);
        default -> -1;
    };
}
int monthDays (String month, int year)
{
    return switch (month.toLowerCase())  {
        case "leden", "bezen", "kvten",
             "ervenec", "srpen", "jen", "prosinec":  yield 31;

        case "duben", "erven", "z", "listopad":     yield 30;

        case "nor":
            int LeapYear = modulo(year, 4) - modulo(year,100)
                                           + modulo(year,400);
            yield 28 + LeapYear;

        default: yield -1;
    };
}
/********************************************************************


/*
** Vpis 6.11: Opertor instanceof
********************************************************************/
0 instaceof Object;      //Lev operand mus bt objekt
(Object)0 instaceof Object;  //Prost petypovn nepome
_Object = 0; //Vyrobil se objekt obalujc zadanou primitivn hodnotu
_Object instanceof Object;  //Je v n odkaz na objekt => projde
_Object instanceof String;  //Nen v n odkaz na String => neprojde
_Object = "xxx";  //Kdy do n ale takov odkaz ulome, ...
_Object instanceof String;  //test projde <= testuje skuten typ
"xxx" instanceof String; //Test literlu neuke nic, co bych nevdl
_Object = null;  //Oficiln je null instanc vech objekt. typ,
_Object instanceof Object; //ale pro instanceof nen instanc dnho
/********************************************************************


/*
** Vpis 6.12: Ukzka pouit shody vzor pro opertor  instanceof
********************************************************************/
String lengthOld(Object o)
{
    return (o instanceof String)
         ? "Dlka je " + ((String)o).length() + " znak."
         : "Objekt " + o + " nen textov etzec.";
}
String lengthNew(Object o)
{
    return (o instanceof String s)
         ? "Dlka je " + s.length() + " znak."
         : "Objekt " + o + " nen textov etzec.";
}
/********************************************************************


/*
** Vpis 6.13: Opertor new
********************************************************************/
_Object = new Object();  //Nov obecn objekt
_Object = new String();  //Bezparametrick konstr. => przdn string
_String = new String("text");  //Nov instance, ale stejn text
_Object == "";  //Stejn text, ale rzn instance
_String == "text";  //Stejn text, ale rzn instance
new Object  //Neek na zvorky, ohls chybu
(new Object  //Vloenm do zvorek jsme jej pinutili ekat, ...
());         //... ne zvorky uzaveme
/********************************************************************


/*
** Vpis 6.14: Priority opertor
********************************************************************/
"Podmnka " + ((1<2)  ?  "plat"  :  "neplat");
"Podmnka " + (1<2)  ?  "plat"  :  "neplat";
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 06H_Remaining_operators.jsh
