/* Historie s oddlovacmi komenti: 17C_Subclassing.jsh
############################## Pli luouk k pl belsk dy
/res   //1         2         3         4         5         6
123456789_123456789_123456789_123456789_123456789_123456789_123456789
/********************************************************************


/*
** Vpis 17.0: Inicializace
********************************************************************/
/set start Start_17.jsh
/reset
/********************************************************************


/*
** Vpis 17.1: Prvn definice tdy Square
********************************************************************/
class Square extends Rectangle {}
void inform(Object o, String message)
{
    String text = message + "\n   " + o;
    System.out.println(text);
    IO.inform(text);
}
void testSquare(Square sq)
{
                                 inform(sq,"Testovan objekt");
    sq.moveRight(100);           inform(sq,"Po posunu o 100 bod vpravo");
    sq.setSize(200);             inform(sq,"Po zmn rozmru na 200");
    sq.setPosition(50, 50);      inform(sq,"Po posunu na pozici [50;50]");
    sq.setColor(NamedColor.GOLD);inform(sq,"Po nastaven zlat barvy");
}
testSquare(new Square());
/********************************************************************


/*
** Vpis 17.2: Definice tdy Square s upravenou verz konstruktoru
********************************************************************/
class Square extends Rectangle
{
    Square()
    {
        super();
        setSize(Canvas.getStep());
    }
}
/-2
/********************************************************************


/*
** Vpis 17.3: Definice tdy Square se tymi konstruktory
********************************************************************/
class Square extends Rectangle
{
    Square()
    {
        this(0, 0);
    }

    Square(int x, int y)
    {
        this(x, y, Canvas.getStep());
    }

    Square(int x, int y, int size)
    {
        super(x, y, size, size);
//    //Tlo by bylo mono stejn dobe definovat pkazem
//    this(x, y, size, DEFAULT_COLOR);
    }

    Square(int x, int y, int size, NamedColor color)
    {
        super(x, y, size, size, color);
    }
}
{ testSquare(new Square());
  testSquare(new Square(50, 100));
  testSquare(new Square(50,  50, 150));
  testSquare(new Square(25,  25,  25, NamedColor.GRAY));
}
/********************************************************************


/*
** Vpis 17.4: Definice tdy Granddaughter
********************************************************************/
/*Definice z NetBeans:
14-28_Projects\src\eu\pedu\b62_j14\c17_inheritance\Granddaughter.java
/********************************************************************


/*
** Vpis 17.5: Definice metody constructorReport(Object,Class)
 *             ve td Reports
********************************************************************/
/*Definice z NetBeans:
14-28_Projects\src\eu\pedu\b62_j14\c17_inheritance\Reports.java
/********************************************************************


/*
** Vpis 17.6: Vytven instanc td v ddick hierarchii
********************************************************************/
/open 17D_Reports.jsh
/open 17D_Mother.jsh
/open 17D_Daughter.jsh
/open 17D_Granddaughter.jsh
{
    new Granddaughter();
    new Daughter();
    new Mother();
}
/********************************************************************


/*
** Zvren uloen
********************************************************************/
/save -history 17H_Subclassing.jsh
