//Soubor: 17S_d3_Granddaughter.jsh
//################################## Pli luouk k pl belsk dy
//#########################################################################

/*******************************************************************************
 * Instance tdy {@code Granddaughter} pedstavuj vnuky.
 *
 * @author  Rudolf PECINOVSK
 * @version 2020-Summer
 */
class Granddaughter extends Daughter
{
    static { println("#####  Zavdm tdu Granddaughter  #####"); }
    { println("+++++  Inicializuji instanci tdy Granddaughter  +++++"); }

    /** Poet doposud vytvoench instanc.*/
    protected static int created = 0;

    /** Rodn slo instance = poad jejho vzniku v rmci tto tdy. */
    protected final String ID = "G"  + ++created + '-' + super.ID;


    /***************************************************************************
     * Konstruktor instance vnuky.
     * Rodiovskm podobjektem je virtuln instance tdy {@link Daughter}.
     */
    public Granddaughter()
    {
        this(null);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kte potebuj nco provst
     * ped zavolnm rodiovskho konstruktoru.
     *
     * @param s Nepouit parametr
     */
    protected Granddaughter(String s)
    {
        super(intermezzo("=== Granddaughter vol rodiovsk konstruktor"));
        constructorReport(this, Granddaughter.class);
    }

    /***************************************************************************
     * Vrt textov podpis instance, tj. jej textovou reprezentaci.
     *
     * @return Textov reprezentace (podpis) dan instance
     */
    @Override
    public String toString()
    {
        return "Granddaughter_" + ID + "(" + super.toString() + ")";
    }

    { println("-----  Konec vodn fze inicializace Granddaughter  -----"); }
    static { println("-----  Tda Granddaughter zavedena  -----"); }
}



//#########################################################################
//save -history 17D_Granddaughter.jsh
