//Soubor: 17D_Mother.jsh
//################################## Pli luouk k pl belsk dy
//#########################################################################

/*******************************************************************************
 * Instance tdy {@code Mother} pedstavuj matky.
 *
 * @author  Rudolf PECINOVSK
 * @version 2020-Summer
 */
class Mother
{
    static { println("#####  Zavdm tdu Mother  #####"); }
    { println("+++++  Inicializuji instanci tdy Mother  +++++"); }

    /** Poet doposud vytvoench instanc.*/
    protected static int created = 0;

    /** Rodn slo instance = poad jejho vzniku v rmci tto tdy. */
    protected final String ID = "M" +  ++created;


    /***************************************************************************
     * Konstruktor instance matky.
     * Rodiovskm podobjektem je virtuln instance tdy {@link Object}.
     */
    public Mother()
    {
//        super();
        constructorReport(this, Mother.class);
    }

    /***************************************************************************
     * Konstruktor pro potomky, kte potebuj nco provst
     * ped zavolnm rodiovskho konstruktoru.
     *
     * @param s Nepouit parametr
     */
    protected Mother(String s)
    {
        this();
    }

    /***************************************************************************
     * Vrt textov podpis instance, tj. jej etzcovou reprezentaci.
     *
     * @return Textov reprezentace (podpis) dan instance
     */
    @Override
    public String toString()
    {
        return "Mother_" + ID + "(Object)";
    }

    { println("-----  Konec vodn fze inicializace Mother  -----"); }
    static { println("-----  Tda Mother zavedena  -----"); }
}



/**Vpis
**************************************************************************/
//#########################################################################
//save -history 17S_d1_Mother.jsh
