





//Soubor: 17D_Reports.jsh
//################################## Pli luouk k pl belsk dy
//#########################################################################

/*********************************************************************
 * Metoda pro vpis zprvy konstruktoru o typu konstruovanho objektu
 * spolu s typem aktuln konstruovanho podobjektu.
 *
 * @param instance Instance vslednho konstruovanho objektu
 * @param cls      Class-objekt tdy volajcho konstruktoru
 */
void constructorReport(Object instance, Class<?> cls)
{
    Class<?> instanceCls = instance.getClass();
    boolean  topType     = instanceCls.equals(cls);
    String callingClass  = cls        .getSimpleName();
    String instanceClass = instanceCls.getSimpleName();
    String indent        = "                        "
                         .substring(0, callingClass.length()+2);
    System.out.println(callingClass + ": Vytvm " + instance + "\n"+
        (topType ? ""
                 : indent + "jako rodiovsk podobjekt objektu typu " +
                   instanceClass));
}


/*********************************************************************
 * Pomocn metoda -- vytiskne argument na standardn vstup
 * a vrt jej jako funkn hodnotu.
 *
 * @param input Titn a vracen objekt
 * @return Argument
 */
String intermezzo(String input)
{
    System.out.println(input);
    return input;
}


/*********************************************************************
 * Vytiskne podpis argumentu na standardn vstup.
 *
 * @param object Titn objekt
 */
void println(Object object)
{
    System.out.println(object);
}



/**Vpis
**************************************************************************/
//#########################################################################
//save -history 17D_Reports.jsh
