//Soubor: Start_26.jsh
//################################## Pli luouk k pl belsk dy

/env -class-path B62_Lib_Pkg.jar

import java.util.*;
import java.util.function.*;
import java.util.regex.*;
import java.util.stream.*;
import eu.pedu.lib20s.canvas.*;
import eu.pedu.lib20s.geom.*;
import eu.pedu.lib20s.util.*;


/***************************************************************************
 * Klon metody ze standardn knihovny.
 *
 * @param obj Objekt, jeho textov podoba se m vytisknout
 */ void println(Object obj)
{
    System.out.println(obj);
}


/***************************************************************************
 * Klon metody ze standardn knihovny.
 *
 * @param obj Objekt, jeho textov podoba se m vytisknout
 */ void print(Object obj)
{
    System.out.print(obj);
}


/**************************************************************************
 * Pevede obsah dvourozmrnho pole na textov etzec tak, e
 * na prvn dek vype zadan titulek
 * a na kad dal pak hodnotu prvku pole.
 */ String arr1toStringln(String title, Object[] arr1)
{
    var stream    = Stream.of(arr1).map(o -> o.toString());
    var collector = Collectors.joining("\n   ", title + "\n   ", "");
    var result    = stream.collect(collector);
    return result;
}


/**************************************************************************
 * Pevede obsah dvourozmrnho pole na textov etzec tak, e
 * na prvn dek vype zadan titulek
 * a na kad dal pak jeden dek pole uvozen indexem danho dku.
 */ String arr2toString(String title, Object[][] arr2)
{
    StringBuilder sb = new StringBuilder(title);
    int index = 0;
    for(Object[] row : arr2) {
        sb.append('\n');
        sb.append(String.format("%3d: ", index++));
        sb.append(Arrays.toString(row));
    }
    return sb.toString();
}


/**************************************************************************
 * Vytiskne nzev zadan tdy nsledovan signaturami
 * atribut, konstruktor a veejnch metod zadan tdy.
 * Seznam neobsahuje metody, kter jsou pouze zddn, ale nepebit.
 */ void printFCM(Class<?> cls)
{
    var fields       = cls.getDeclaredFields();
    var constructors = cls.getConstructors();
    var methods      = cls.getDeclaredMethods();
    var stream = Stream.concat(Arrays.stream(fields),
                 Stream.concat(Arrays.stream(constructors),
                               Arrays.stream(methods)))
                .map(o -> o.toString());
    var collector = Collectors.joining("\n   ",
                    "\nAtributy, konstruktory a veejn metody tdy "
                  + cls.getSimpleName() + "\n   ",
                    "");
    var result = stream.collect(collector);
    result = result.replaceAll("REPL.\\$JShell\\$.+\\$", "");
    println(result);
}


/**************************************************************************
 * Vytiskne nzev zadan tdy nsledovan signaturami
 * atribut, konstruktor a veejnch metod matesk tdy zadan instance.
 * Seznam neobsahuje metody, kter jsou pouze zddn, ale nepebit.
 */ void printFCM(Object o)
{
    printFCM(o.getClass());
}

/**************************************************************************
 * Vrt informacio to, shodujli se zadan parametry
 * se zadanou relativn pesnost.
 * @param d1 Prvn z porovnvanch hodnot
 * @param d2 Druh z porovnvanch hodnot
 * @param precision Zadan lativn pesnost
 */ boolean equalsDouble(double d1, double d2, double precision)
{
    double max = Math.max(Math.abs(d1), Math.abs(d2));
    double dif = (d2 - d1) / max;
    println("dif = " + dif);
    return Math.abs(dif) < precision;
}

/**Rekapitulace
**************************************************************************/
//#########################################################################
//save -history Start_26.jsh
/imports
/vars
/methods
/types
